package de.oaa.xxx.aufgaben.entity;

import de.oaa.xxx.aufgaben.Aufgabe;
import de.oaa.xxx.aufgaben.Werkzeug;
import jakarta.persistence.CascadeType;
import jakarta.persistence.CollectionTable;
import jakarta.persistence.Column;
import jakarta.persistence.ElementCollection;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.JoinTable;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

import java.util.List;
import java.util.UUID;

@Entity
@Table(name = "aufgabe")
public class AufgabeEntity {

    @Id
    @Column
    private UUID aufgabeId;
    @Column
    private String kurzText;
    @Column(columnDefinition = "TEXT")
    private String text;
    @Column
    private Integer level;
    @Column
    private Integer sekundenVon;
    @Column
    private Integer sekundenBis;
    @ManyToOne
    @JoinColumn(name = "gruppeId")
    private AufgabenGruppeEntity aufgabenGruppe;
    @Enumerated(EnumType.STRING)
    @ElementCollection(targetClass = Werkzeug.class)
    @CollectionTable(name = "aufgabe_benoetigtAktiv", joinColumns = @JoinColumn(name = "aufgabeId"))
    @Column(name = "werkzeug")
    private List<Werkzeug> benoetigtAktiv;
    @Enumerated(EnumType.STRING)
    @ElementCollection(targetClass = Werkzeug.class)
    @CollectionTable(name = "aufgabe_benoetigtPassiv", joinColumns = @JoinColumn(name = "aufgabeId"))
    @Column(name = "werkzeug")
    private List<Werkzeug> benoetigtPassiv;
    @ManyToMany(cascade = CascadeType.DETACH)
    @JoinTable(name = "aufgabeToy", joinColumns = {@JoinColumn(name = "aufgabeId")}, inverseJoinColumns = {@JoinColumn(name = "toyId")})
    private List<ToyEntity> benoetigteToys;

    public UUID getAufgabeId() { return aufgabeId; }
    public void setAufgabeId(UUID aufgabeId) { this.aufgabeId = aufgabeId; }

    public String getKurzText() { return kurzText; }
    public void setKurzText(String kurzText) { this.kurzText = kurzText; }

    public String getText() { return text; }
    public void setText(String text) { this.text = text; }

    public Integer getLevel() { return level; }
    public void setLevel(Integer level) { this.level = level; }

    public Integer getSekundenVon() { return sekundenVon; }
    public void setSekundenVon(Integer sekundenVon) { this.sekundenVon = sekundenVon; }

    public Integer getSekundenBis() { return sekundenBis; }
    public void setSekundenBis(Integer sekundenBis) { this.sekundenBis = sekundenBis; }

    public AufgabenGruppeEntity getAufgabenGruppe() { return aufgabenGruppe; }
    public void setAufgabenGruppe(AufgabenGruppeEntity aufgabenGruppe) { this.aufgabenGruppe = aufgabenGruppe; }

    public List<Werkzeug> getBenoetigtAktiv() { return benoetigtAktiv; }
    public void setBenoetigtAktiv(List<Werkzeug> benoetigtAktiv) { this.benoetigtAktiv = benoetigtAktiv; }

    public List<Werkzeug> getBenoetigtPassiv() { return benoetigtPassiv; }
    public void setBenoetigtPassiv(List<Werkzeug> benoetigtPassiv) { this.benoetigtPassiv = benoetigtPassiv; }

    public List<ToyEntity> getBenoetigteToys() { return benoetigteToys; }
    public void setBenoetigteToys(List<ToyEntity> benoetigteToys) { this.benoetigteToys = benoetigteToys; }

    public Aufgabe toAufgabe() {
        Aufgabe aufgabe = new Aufgabe();
        aufgabe.setAufgabeId(aufgabeId);
        aufgabe.setBenoetigtAktiv(benoetigtAktiv);
        aufgabe.setBenoetigteToys(benoetigteToys.stream().map(ToyEntity::toToy).toList());
        aufgabe.setBenoetigtPassiv(benoetigtPassiv);
        aufgabe.setGruppeId(aufgabenGruppe.getGruppenId());
        aufgabe.setKurzText(kurzText);
        aufgabe.setLevel(level);
        aufgabe.setSekundenBis(sekundenBis);
        aufgabe.setSekundenVon(sekundenVon);
        aufgabe.setText(text);
        return aufgabe;
    }

    public static AufgabeEntity create(Aufgabe aufgabe, AufgabenGruppeEntity aufgabenGruppeEntity) {
        AufgabeEntity entity = new AufgabeEntity();
        entity.setAufgabeId(UUID.randomUUID());
        entity.setAufgabenGruppe(aufgabenGruppeEntity);
        entity.setBenoetigtAktiv(aufgabe.getBenoetigtAktiv());
        entity.setBenoetigteToys(aufgabe.getBenoetigteToys().stream().map(toy -> ToyEntity.create(toy, aufgabenGruppeEntity)).toList());
        entity.setBenoetigtPassiv(aufgabe.getBenoetigtPassiv());
        entity.setKurzText(aufgabe.getKurzText());
        entity.setLevel(aufgabe.getLevel());
        entity.setSekundenBis(aufgabe.getSekundenBis());
        entity.setSekundenVon(aufgabe.getSekundenVon());
        entity.setText(aufgabe.getText());
        return entity;
    }
}
